#import <appkit/appkit.h>
#import "CIC_Module.h"		// Replace "CIC_Module" with your module's name

@implementation CIC_Module	// Again, put your module name here


// required methods:

- initFromPath:(const char *)path
{
     char       fname[MAXPATHLEN];
     
     strcat(strcpy(fname,[self name]),CIC_NIB_EXT);
     if([NXApp loadNibSection:fname owner:self withNames:NO] == nil){
          fprintf(stderr,"Module %s: Cannot load %s!\n",[self name],fname);
          return nil;
     }
     else
          return self;
}

// Enable this method if you want to import an image in CIC.
// Start a modal loop, do your specific image acquiration, fulfill the
// imageInfo, and return YES or NO, depending on a successful or
// unsuccessful completion of the acquiration process.
// You must assign values to the following IMAGE_INFO entries:
/*
     imageInfo->data
     imageInfo->dpi
     imageInfo->extractionFactor
     imageInfo->info.image.width
     imageInfo->info.image.height
     imageInfo->info.image.samplesPerPixel
     imageInfo->info.image.planarConfig		(NX_MESHED or NX_PLANAR)
	imageInfo->info.image.bitsPerSample
     imageInfo->hasAlpha
     imageInfo->colorSpace
	imageInfo->fname		(optional; full or relative pathname)
*/

/*
- (BOOL)getImage:(IMAGE_INFO *)imageInfo
{
	return(NO);
}
*/

// Enable this method if you want to export an image from CIC.
// If you want to run a non-modal export panel and to allow the user
// to export the current image at any time, use this method to
// order your panel in front and call another method for actual
// output. You may obtain the imageInfo of the current image by:
// IMAGE_INFO *imageInfo = [[[NXApp delegate] compositeView] ac_imageInfo];

/*
- (BOOL)putImage:(IMAGE_INFO *)imageInfo
{
	return(NO);
}
*/

// optional method:

- (const char *)moduleName
{
     return [stringTable valueForStringKey:"moduleName"];
}

@end
